# Personal Ortho 4x12 Layout of BifbofII

![BifbofII Ortho 4x12 Layout](https://i.imgur.com/hHSexjE.jpeg)

## QWERTY Layer

```
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
| Tab |  Q  |  W  |  E  |  R  |  T  |  Y  |  U  |  I  |  O  |  P  | Bsp |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
| Esc |  A  |  S  |  D  |  F  |  G  |  H  |  J  |  K  |  L  |  ;  |  '  |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|Shift|  Z  |  X  |  C  |  V  |  B  |  N  |  M  |  ,  |  .  |  /  | Ret |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|Ctrl |Super|     | Alt |Lower| Spc | Spc |Raise| Alt |Super|Ctrl |Spec |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
```

Holding the Space Bar switches to the Function layer.

## Raise

```
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|  `  |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |  9  |  0  | Bsp |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|     | F1  | F2  | F3  | F4  | F5  | F6  |  -  |  =  |  [  |  ]  |  \  |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|     | F7  | F8  | F9  | F10 | F11 | F12 |     |     |     |     |     |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|     |     |     |     |     |     |     |     |     |     |     |     |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
```

## Lower

```
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|  ~  |  !  |  @  |  #  |  $  |  %  |  ^  |  &  |  *  |  (  |  )  | Bsp |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|     |     |     |     |     |     |     |  _  |  +  |  {  |  }  |  |  |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|     |     |     |     |     |     |     |     |     |     |     |     |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|     |     |     |     |     |     |     |     |     |     |     |     |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
```

## Function Layer

```
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|     |     |     |     |     |Mute |Prev |Vol- |Vol+ |Next |Play | Del |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|Caps |     |  <  |     |     |  >  |Left |Down | Up  |Right|     |     |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|     |     |     |     |     |     |Home |Page-|Page+| End |     |     |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|     |     |     |     |     |     |     |     |     |     |     |     |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
```

## Unicode Layer

```
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|     |     |     |  €  |     |     |     |  Ü  |     |  Ö  |     |     |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|     |  Ä  |  ß  |     |     |     |     |     |     |     |     |     |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|     |     |     |  ©  |     |     |     |     |     |     |     |     |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
|     |     |     |     |     |     |     |     |     |     |     |     |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
```

## Specials Layer

```
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
| XXX | XXX | Win | XXX | XXX | XXX | XXX | XXX | XXX | OSX | XXX | XXX |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
| XXX | XXX | XXX | XXX | XXX | XXX | XXX | XXX | XXX | Lnx | XXX | XXX |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
| XXX | XXX | XXX | XXX | XXX |QK_BOOT| XXX | XXX | XXX | XXX | XXX | XXX |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
| XXX | XXX | XXX | XXX | XXX | XXX | XXX | XXX | XXX | XXX | XXX | XXX |
+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
```
